var count;
var db;
var offset = 0;
var id;

async function dbConnect() {
    db = new miletus.DataBase('sqlite', {database: "todo.db"});
    await db.connect();
    let res = await db.query('SELECT COUNT(*) AS count FROM tasks;');
    count = res.result[0].count;

    if (count > 1) {
        document.getElementById('next').disabled = false;
        document.getElementById('last').disabled = false;
    
        res = await db.query('select * from tasks limit 1 offset 0');
        id = res.result[0].Id;
        document.getElementById("descr").value = res.result[0].descr;
        document.getElementById("status").value = res.result[0].status;
        document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);
    }

    document.getElementById("insert").disabled = false;
    document.getElementById("update").disabled = false;
    document.getElementById("delete").disabled = false;
    document.getElementById("descr").disabled = false;
    document.getElementById("task-date").disabled = false;
    document.getElementById("status").disabled = false;
    document.getElementById("connect").disabled = true;
}

async function firstPage() {
    document.getElementById('first').disabled = true;
    document.getElementById('prev').disabled = true;
    document.getElementById('next').disabled = false;
    document.getElementById('last').disabled = false;

    let res = await db.query('select * from tasks limit 1 offset 0');
    id = res.result[0].Id;
    document.getElementById("descr").value = res.result[0].descr;
    document.getElementById("status").value = res.result[0].status;
    document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);

    offset = 0;
}

async function prevPage() {
    document.getElementById('next').disabled = false;
        document.getElementById('last').disabled = false;
    if ((offset - 1) === 0) {
        document.getElementById('first').disabled = true;
        document.getElementById('prev').disabled = true;
    }

    let res = await db.query('select * from tasks limit 1 offset ' + (offset - 1));
    id = res.result[0].Id;
    document.getElementById("descr").value = res.result[0].descr;
    document.getElementById("status").value = res.result[0].status;
    document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);

    offset = offset - 1;
}

async function nextPage() {
    offset = offset + 1;
    document.getElementById('first').disabled = false;
    document.getElementById('prev').disabled = false;
    if ((offset + 1) >= count) {
        document.getElementById('next').disabled = true;
        document.getElementById('last').disabled = true;
    }

    let res = await db.query('select * from tasks limit 1 offset ' + offset);
    id = res.result[0].Id;
    document.getElementById("descr").value = res.result[0].descr;
    document.getElementById("status").value = res.result[0].status;
    document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);
}

async function lastPage() {
    document.getElementById('first').disabled = false;
    document.getElementById('prev').disabled = false;
    document.getElementById('next').disabled = true;
    document.getElementById('last').disabled = true;

    offset = count - 1;
    let res = await db.query('select * from tasks limit 1 offset ' +  offset);
    id = res.result[0].Id;
    document.getElementById("descr").value = res.result[0].descr;
    document.getElementById("status").value = res.result[0].status;
    document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);
}

async function update() {
    let query = 'update tasks set descr="' + document.getElementById("descr").value + '", status="' + document.getElementById('status').value + '", due_date=date("' + document.getElementById('task-date').value + '") where Id=' + id;
    await db.query(query);
}

async function insert() {
    if (document.getElementById('insert').textContent === "Insert") {
        document.getElementById("descr").value = "";
        document.getElementById('status').value = "New";
        document.getElementById('task-date').valueAsDate = new Date();

        offset = count;
        count = count + 1;

        document.getElementById('first').disabled = true;
        document.getElementById('prev').disabled = true;
        document.getElementById('next').disabled = true;
        document.getElementById('last').disabled = true;
        document.getElementById("update").disabled = true;
        document.getElementById("delete").disabled = true;

        document.getElementById('insert').textContent = "Save";
    } else {
        let query = 'insert into tasks (descr, status, due_date) values ("' + document.getElementById("descr").value + '", "' + document.getElementById('status').value + '", date("' + document.getElementById('task-date').value + '"))';
        await db.query(query);
        let res = await db.query('select * from tasks limit 1 offset ' + offset);
        id = res.result[0].Id;

        document.getElementById('first').disabled = false;
        document.getElementById('prev').disabled = false;
        document.getElementById("update").disabled = false;
        document.getElementById("delete").disabled = false;

        document.getElementById('insert').textContent = "Insert";
    }
}

async function del() {
    if (offset > 0) { 
        offset = offset - 1 
    }

    count = count - 1;
    await db.query('delete from tasks where Id=' + id);
    let res = await db.query('select * from tasks limit 1 offset ' + offset);
    id = res.result[0].Id;
    document.getElementById("descr").value = res.result[0].descr;
    document.getElementById("status").value = res.result[0].status;
    document.getElementById("task-date").value = res.result[0].due_date.substring(0,10);

    if (count === 1) {
        document.getElementById('first').disabled = true;
        document.getElementById('prev').disabled = true;
        document.getElementById('next').disabled = true;
        document.getElementById('last').disabled = true;
    }
}

window.addEventListener('beforeunload', function (e) {
    if (db) {
        db.close();
    }
});